#include "geotrace.h"

void usage();

int debug_mode;

int main (int argc, char *argv[]) {
	int c,runtrace=0;

	if (debug_mode)
		fprintf (stdout,"(geotrace.c) main\n");

	g_thread_init(NULL);
	gtk_init (&argc, &argv);
	get_prefs_from_file();
	create_window();
	gdk_color_alloc (gtk_widget_get_colormap(drawing_area),my_gdk_color);

	// scan command line args
	while ((c=getopt(argc,argv,"dhi:m:")) != EOF) {
		switch (c) {
		case 'd':
			fprintf (stdout,"Entering debug mode\n");
			debug_mode = 1;
			break;
		case 'h':
			usage();
			break;
		case 'i':
			gtk_entry_set_text(GTK_ENTRY(host_entry),optarg);
			runtrace = 1;
			break;
		case 'm':
			strcpy (start_map,optarg);
			break;
		default:
			usage();
		}
	}

	scan_maps_file();
	gtk_widget_show (window);
	gdk_rgb_init();
	set_map_from_file(curmap);
	statusbar_msg = gtk_statusbar_get_context_id(GTK_STATUSBAR(status_bar),"New");
	gtk_statusbar_push (GTK_STATUSBAR(status_bar),GPOINTER_TO_INT(&statusbar_msg),"Welcome to GeoTrace");
	popup_msg = malloc (100);
	if (first_time) {
		sprintf (popup_msg,"Check the paths in the options.");
		create_popup_window();
		gtk_widget_show (popup_window);
	} else if (runtrace)
		trace_button_clicked();
	gtk_main ();
	return (0);
}

void usage () {
	fprintf (stdout,"Usage: geotrace [-hd] [-i host] [-m map]\n");
	fprintf (stdout,"	-i host specify the host to trace\n");
	fprintf (stdout,"	-m map	set startup map\n");
	fprintf (stdout,"	-d	debug mode\n");
	fprintf (stdout,"	-h	this help\n");
	exit(1);
}
